;##################################################
;##                                              ##
;##        [ Asm7x.List ][ IQSrt4S1.inc ]        ##
;##                                              ##
;##            -= Smart Quick Sort =-            ##
;##     (for single extended element arrays)     ##
;##                                              ##
;##             ஢           ##
;##  (ᨢ  묨 ७.⠬)  ##
;##                                              ##
;##           [ v1.00 :: 11.11.2017 ]            ##
;##           MASM/TASM (16 bit 386+)            ##
;##                                              ##
;##     (c) 2017 by Jin X (jin.x@sources.ru)     ##
;##             http://xk7.ru/p/a/i              ##
;##                                              ##
;##################################################

IFDEF		??Version	; TASM
  LOCALS
ENDIF

IQSort4S1_ver	=	100h			;    (word: 訩  - 楫 , 訩 - ஡)

; !!!   㫥 ᯮ  ࠢ 祭  ஢   ( 襣  襬)
; !!!     ࠢ  ஢   室  ᮮ⢥騥 樨, 祭   ᨬ ***

; IQSort4InsThrs = ண ᯮ짮 ஢ ⠢ ( - ⮢  㪠  祭) [ 2;  㬮砭 16]
;   ᫨ - ⮢ ( ࢮ  ᫥饩 樨)   ࠢ 祭 IQSort4InsThrs, ᯮ  ஢, 
;   ᯮ ஢ ⠢ -   ᪮  ( ࠢ쭮 롮 祭 IQSort4InsThrs, ਬ,  祭  㬮砭)
;    㬥蠥 㡨 ४ᨨ,  ⥪  ९
IQSort4InsThrs	=	16

; IQSort4MaxStk = ᨬ ࠧ ⥪  ,  ⨬ ᯮ짮 楤 IQSort4 ( call  ᭮ ) [ 10;  㬮砭 128]
;    ஢  ᯮ 4  (2 ᫮) ⥪ ( ஢ -  4- ᫮, ᫥  ᯮ짮  1 ᫮ , ⮣  10 ),
;   .. 128   ࣠  30 ஢ ४ᨨ,  筮   祭  ᨢ
IQSort4MaxStk	=	128

;-----------------------------------------------------------------------------------------------------------------------

;-- IQSort4:    ᨢ (஢ ⮤) ------------------------------------------------
; > 室 : DS:DX =  ᨢ, CX = - ⮢ ᨢ ( 祭)
; > : ஢ ᨢ ( ⮬  )
;  ᨢ ᮤঠ  1 祭 ⨯ DWORD,  ஬ ந室 ࠢ  ஢
; ᫨ - ⮢ ( ࢮ  ᫥饩 樨)   ࠢ 祭 IQSort4InsThrs, ᯮ  ஢,
;    ᯮ ஢ ⠢
; ஢ ⠢ ⠪ ᯮ, ᫨  ᫥饣 ஢ ४ᨨ ॡ  IQSort4MaxStk  ⥪  饬 ᫮
; 楤  ॣ EAX, EBX, CX, DX, SI, DI, 襥 ᫮ EBP; ࠭ BP  ᥣ ॣ
IQSort4		PROC
		dec	cx
		jle	@@exit			; 室, ᫨ - ⮢ <= 1

		push	bp
		xor	bp,bp			; BP = - ४ᨩ
		shl	cx,2
		add	cx,dx			; CX =  ᫥ 

		;  楤 ன ஢
		; DX =  ࢮ , CX =  ᫥ , CX > DX, BP = ஢ ४ᨨ
	@@IQSort4Main:
		mov	ax,cx
		sub	ax,dx
		shr	ax,2			; AX = - ⮢  1
		cmp	ax,IQSort4InsThrs-1
		jb	@@callins		; ᫨ - ⮢  ண 祭, ᯮ㥬 ஢ ⠢

		mov	si,dx			;; I (SI) := L (DX)
	@@repeat1:				;; repeat
		mov	di,cx			;; J (DI) := R (CX)
		mov	bx,cx
		sub	bx,dx
		shr	bx,1
		and	bx,-4
		add	bx,dx			;; P (BX) := (L + R) / 2
		mov	eax,[bx]		;; T (EAX) := [P]
	@@repeat2 = @@cmpI			;; repeat
		; SI = I, EAX = T, DI = J, DX = L, CX = R
		jmp	@@cmpI
	@@addI:	add	si,4			;; Inc(I)
	@@cmpI:	cmp	[si],eax		;; while [I] < T
		jl	@@addI			; {*** ஢  ⠭: jl -  ࠢ, jb - ;  뢠: jg - , ja - }

		jmp	@@cmpJ
	@@subJ:	sub	di,4			;; Dec(J)
	@@cmpJ:	cmp	[di],eax		;; while [J] > T
		jg	@@subJ			; {*** ஢  ⠭: jg -  ࠢ, ja - ;  뢠: jl - , jb - }

		cmp	si,di
		jnbe	@@noswap		;; if I <= J then

		mov	ebx,[si]		;;   Swap [I],[J]
		xchg	[di],ebx
		mov	[si],ebx

		add	si,4			;; Inc(I)
		sub	di,4			;; Dec(J)
	@@noswap:
		cmp	si,di
		jna	@@repeat2		;; until I > J

		cmp	dx,di
		jnb	@@norecurs		;; if L < J then

		push	cx
		push	si			; ࠭塞 R  I
		mov	cx,di
		; DX = L, CX = J
		cmp	bp,(IQSort4MaxStk-10)/4	; 5 ᫮ -     뢠 ணࠬ + bp + cx + si +    InsSort4
		jae	@@callins2		; ᫨ ᫮ ४ᨩ ⨣ ᨬ㬠,   맮 ஢ ⠢: InsSort4(L, J)
		inc	bp			;  㢥稢 㡨 ४ᨨ    ४
		jmp	@@IQSort4Main		;;   IQSort4(L, J); 맮  १ jmp   ⥪ :)
	@@recursret:
		pop	si
		pop	cx			; ⠭ I  R
	@@norecurs:
		mov	dx,si			;; L := I
		cmp	si,cx
		jnae	@@repeat1		;; until I >= R
	@@finish:
		dec	bp			; 㬥蠥 㡨 ४ᨨ
		jns	@@recursret		; 룠, ᫨    (୥) ஢ ४ᨨ
		pop	bp
	@@exit:	ret

	@@callins:
		push	offset @@finish		;  
		jmp	@IQInsSort4		;  call + jmp @@finish  push + jmp
	@@callins2:
		push	offset @@recursret	;  
		jmp	@IQInsSort4		;  call + jmp @@recursret  push + jmp
IQSort4		ENDP

;-- InsSort4:  ᨢ  -----------------------------------------------------------------------------
; > 室 : DS:DX =  ᨢ, CX = - ⮢ ᨢ ( 祭)
; > : ஢ ᨢ ( ⮬  )
;  ᨢ ᮤঠ  1 祭 ⨯ DWORD,  ஬ ந室 ࠢ  ஢
; 楤  ॣ EAX, EBX, CX, DX, SI, DI, 襥 ᫮ EBP; ࠭ BP  ᥣ ॣ
InsSort4	PROC
		dec	cx
		jle	@@exit			; 室, ᫨ - ⮢ <= 1

		shl	cx,2
		add	cx,dx			; CX =  ᫥ 

		;  楤 ஢ ⠢
		; DX =  ࢮ , CX =  ᫥ , CX > DX
IFDEF		??Version	; TASM
  @IQInsSort4:
ELSE				; MASM
  @IQInsSort4::
ENDIF
		mov	di,dx			; J (DI) := L -  ࢮ 
	@@next:					;; for J (DI) := L+1 (CX) to R (DX) do
		add	di,4			; J++ (DI) -  ᫥饣 ஢塞  ( ᭮ 横)
		mov	ebx,[di]		;; T (EBX) := [J]
		mov	si,di			; I+1 (SI) := DI -  , ᫥饣  ࠢ ( ७ 横)
	@@loop:					;; repeat
		mov	eax,[si-4]
		cmp	eax,ebx			;; if [I] > T then
		jle	@@break			; 룠, ᫨ [I] <= T {*** ஢  ⠭: jle -  ࠢ, jbe - ;  뢠: jge - , jae - }

		mov	[si],eax		;;  [I+1] := [I] else Break

		sub	si,4			;; Dec(I)
		cmp	si,dx
		jnbe	@@loop			;; until I < L (I+1 <= L)
	@@break:
		mov	[si],ebx		;; [I+1] := T

		cmp	di,cx
		jnae	@@next			; ᫥騩  ᨢ ;; end for
	@@exit:	ret
InsSort4	ENDP
