;##################################################
;##                                              ##
;##         [ Asm7x.List ][ QSort4.inc ]         ##
;##                                              ##
;##          UNIVERSAL UNIT FOR 16 BIT           ##
;##          16         ##
;##                                              ##
;##               -= Quick Sort =-               ##
;##        (for extended elenemt arrays)         ##
;##                                              ##
;##               ஢              ##
;##   ( ᨢ  ७묨 ⠬)   ##
;##                                              ##
;##           [ v1.00 :: 11.11.2017 ]            ##
;##           MASM/TASM (16 bit 386+)            ##
;##                                              ##
;##     (c) 2017 by Jin X (jin.x@sources.ru)     ##
;##             http://xk7.ru/p/a/i              ##
;##                                              ##
;##################################################

IFDEF		??Version	; TASM
  LOCALS
ENDIF

QSort4_ver	=	100h			;    (word: 訩  - 楫 , 訩 - ஡)

;       **   :

; Sort4SignCmp = 1 -  ࠢ, 0 -  [ 㬮砭 1]

; Sort4Ascending = 1 - ஢  ⠭ ( 襣  襬), 0 -  뢠 ( 쥣  襬)

; Sort4ElemDWords = -  ᫮  묨 (᪠ 祭: 1 - ⮫쪮 ୮ ᫮, 2 - ୮ ᫮  易 ; 㣨 祭 த 訡)
;   [*    *, 祭  㬮砭   !!!]

;-----------------------------------------------------------------------------------------------------------------------

_defdef		MACRO	Const:REQ, DefVal:REQ
  IFDEF		Const
	_&Const	=	Const
  ELSE
	_&Const	=	DefVal
  ENDIF
ENDM

@386		=	((@Cpu and 8) ne 0) or ((@Cpu and 2Fh) eq 0)

IF	not @386
  IFDEF		??Version	; TASM
    .ERR	"This module requires 386+ instructions enabled !!!"
  ELSE				; MASM
    .ERR	<This module requires 386+ instructions enabled !!!>
  ENDIF
ENDIF

_defdef	Sort4SignCmp, 1
_defdef	Sort4Ascending, 1

IF	_Sort4SignCmp
  IF	_Sort4Ascending
    srt?jl	EQU	<jl>
    srt?jg	EQU	<jg>
  ELSE
    srt?jl	EQU	<jg>
    srt?jg	EQU	<jl>
  ENDIF
ELSE
  IF	_Sort4Ascending
    srt?jl	EQU	<jb>
    srt?jg	EQU	<ja>
  ELSE
    srt?jl	EQU	<ja>
    srt?jg	EQU	<jb>
  ENDIF
ENDIF

_Sort4ElemDWords =	Sort4ElemDWords
IF	(_Sort4ElemDWords+1)/2 ne 1
  IFDEF		??Version	; TASM
    .ERR	"Wrong value of Sort4ElemDWords, it must be = 1 or 2 !!!"
  ELSE				; MASM
    .ERR	<Wrong value of Sort4ElemDWords, it must be = 1 or 2 !!!>
  ENDIF
ENDIF
_Sort4ElemSize	=	_Sort4ElemDWords*4	; ࠧ   ᨢ (4  8 )

;-- QSort4:   ᨢ ----------------------------------------------------------------------------------
; > 室 : DS:DX =  ᨢ, CX = - ⮢ ᨢ ( 祭)
; > : ஢ ᨢ ( ⮬  )
; ᫨  ᨢ ᮤঠ  2 祭, .. Sort4ElemDWords = 2 (ࠧ  ᨢ = _Sort4ElemSize = 8 ⠬), :
;   * ࢮ  ᫮ ᮤন ୮ 祭 ( ஬ ந室 ࠢ),
;   * ஥  ᫮ - 易  ⮬  (筮  㪠⥫  );
;      ஢ 易  ७   묨 祭ﬨ
; 楤  ॣ EAX, EBX, CX, DX, SI, DI, 襥 ᫮ EBP; ࠭ BP  ᥣ ॣ
QSort4		PROC
		dec	cx
		jle	@@exit			; 室, ᫨ - ⮢ <= 1

		push	bp
		xor	bp,bp			; BP = - ४ᨩ
		shl	cx,_Sort4ElemDWords+1
		add	cx,dx			; CX =  ᫥ 

		;  楤 ன ஢
		; DX =  ࢮ , CX =  ᫥ , CX > DX, BP = ஢ ४ᨨ
	@@QSort4Main:
		mov	si,dx			;; I (SI) := L (DX)
	@@repeat1:				;; repeat
		mov	di,cx			;; J (DI) := R (CX)
		mov	bx,cx
		sub	bx,dx
		shr	bx,1
		and	bx,-_Sort4ElemSize
		add	bx,dx			;; P (BX) := (L + R) / 2
		mov	eax,[bx]		;; T (EAX) := [P]
	@@repeat2 = @@cmpI			;; repeat
		; SI = I, EAX = T, DI = J, DX = L, CX = R
		jmp	@@cmpI
	@@addI:	add	si,_Sort4ElemSize	;; Inc(I)
	@@cmpI:	cmp	[si],eax		;; while [I] < T
		srt?jl	@@addI

		jmp	@@cmpJ
	@@subJ:	sub	di,_Sort4ElemSize	;; Dec(J)
	@@cmpJ:	cmp	[di],eax		;; while [J] > T
		srt?jg	@@subJ

		cmp	si,di
		jnbe	@@noswap		;; if I <= J then

		mov	ebx,[si]
		xchg	[di],ebx
		mov	[si],ebx
IF	_Sort4ElemDWords gt 1
		mov	ebx,[si+4]
		xchg	[di+4],ebx
		mov	[si+4],ebx
ENDIF
		add	si,_Sort4ElemSize	;; Inc(I)
		sub	di,_Sort4ElemSize	;; Dec(J)
	@@noswap:
		cmp	si,di
		jna	@@repeat2		;; until I > J

		cmp	dx,di
		jnb	@@norecurs		;; if L < J then

		push	cx
		push	si			; ࠭塞 R  I
		mov	cx,di
		; DX = L, CX = J
		inc	bp			; 㢥稢 㡨 ४ᨨ    ४
		jmp	@@QSort4Main		;;   QSort4(L, J); 맮  १ jmp   ⥪ :)
	@@recursret:
		pop	si
		pop	cx			; ⠭ I  R
	@@norecurs:
		mov	dx,si			;; L := I
		cmp	si,cx
		jnae	@@repeat1		;; until I >= R
	@@finish:
		dec	bp			; 㬥蠥 㡨 ४ᨨ
		jns	@@recursret		; 룠, ᫨    (୥) ஢ ४ᨨ
		pop	bp
	@@exit:	ret
QSort4		ENDP
